diff -urN soojung-0.4.5/TODO soojung/TODO
--- soojung-0.4.5/TODO	2004-12-24 12:09:15.000000000 +0900
+++ soojung/TODO	2005-03-11 22:03:46.000000000 +0900
@@ -7,5 +7,4 @@
 카테고리 대분류(혹은 다중 깊이 트리)
 plugin 환경 구축
 설치 할 때 인코딩 설정 할 수 있게 만들기(기본은 utf-8)
-달력보여주기 (글 쓴 날짜, 안 쓴 날자, 전달, 월별 archive 별 달력)
 모니위키와 연동 기능, 혹은 키워드 설정기능
diff -urN soojung-0.4.5/admin.php soojung/admin.php
--- soojung-0.4.5/admin.php	2005-02-19 18:07:16.000000000 +0900
+++ soojung/admin.php	2005-03-11 22:03:46.000000000 +0900
@@ -115,6 +115,7 @@
   $template->assign("admin_name", $admin_name);
   $template->assign("admin_email", $admin_email);
   $template->assign("templates", Soojung::getTemplates());
+  $template->assign("config_writable", is_writable("config.php"));
   $template->display('config.tpl');
 } else if ($_GET["mode"] == "data") {
   $template->display('data.tpl');
@@ -127,13 +128,13 @@
   if ($page > 1) {
     $template->assign('prev_page_link', "admin.php?mode=list&page=" . ($page - 1));
   }
-  if (Entry::getEntryCount() > $page * 10) {
+  if (Entry::getEntryCount(false) > $page * 10) {
     $template->assign('next_page_link', "admin.php?mode=list&page=" . ($page + 1));
   }
-  $template->assign('entries', Entry::getEntries(10, $page));
+  $template->assign('entries', Entry::getEntries(10, $page, false));
   $template->display('list.tpl');
 } else {
-  $template->assign('recent_entries', Entry::getRecentEntries(5));
+  $template->assign('recent_entries', Entry::getRecentEntries(5, false));
   $template->assign('recent_comments', Comment::getRecentComments(5));
   $template->assign('recent_trackbacks', Trackback::getRecentTrackbacks(5));
   $template->assign('entry_count', Entry::getEntryCount());
diff -urN soojung-0.4.5/classes/Bookmark.class.php soojung/classes/Bookmark.class.php
--- soojung-0.4.5/classes/Bookmark.class.php	2005-02-20 11:13:25.000000000 +0900
+++ soojung/classes/Bookmark.class.php	2005-03-01 02:01:20.000000000 +0900
@@ -22,8 +22,8 @@
     $fd = fopen($filename, "r");
     $this->number = Soojung::filenameToEntryId($filename);
     $this->name = trim(strstr(fgets($fd, 1024), ' '));
-    $this->url = htmlspecialchars(trim(strstr(fgets($fd, 1024), ' ')), ENT_QUOTES, "UTF-8");
-    $this->image = htmlspecialchars(trim(strstr(fgets($fd, 1024), ' ')), ENT_QUOTES, "UTF-8");
+    $this->url = trim(strstr(fgets($fd, 1024), ' '));
+    $this->image = trim(strstr(fgets($fd, 1024), ' '));
     $this->desc = trim(strstr(fgets($fd, 1024), ' '));
     fclose($fd);
   }
diff -urN soojung-0.4.5/classes/Calendar.class.php soojung/classes/Calendar.class.php
--- soojung-0.4.5/classes/Calendar.class.php	2005-02-19 10:46:05.000000000 +0900
+++ soojung/classes/Calendar.class.php	2005-03-08 22:28:41.000000000 +0900
@@ -81,8 +81,8 @@
       }
       $weekday = ($weekday + 1) % 7;
     }
-    if ($weekday < 6) {
-      $cal .= "</tr>\n";
+    if ($weekday > 0) {
+      $cal .= str_repeat("<td></td>", 7-$weekday)."</tr>\n";
     }
     $cal .= "</table></div>\n";
     return $cal;
diff -urN soojung-0.4.5/classes/Entry.class.php soojung/classes/Entry.class.php
--- soojung-0.4.5/classes/Entry.class.php	2005-02-19 05:37:25.000000000 +0900
+++ soojung/classes/Entry.class.php	2005-03-11 22:09:36.000000000 +0900
@@ -35,7 +35,7 @@
     
     //read header
     $this->date = trim(strstr(fgets($fd, 1024), ' '));
-    $this->title = htmlspecialchars(trim(strstr(fgets($fd, 1024), ' ')), ENT_QUOTES, "UTF-8");
+    $this->title = trim(strstr(fgets($fd, 1024), ' '));
     $this->category = new Category(trim(strstr(fgets($fd, 1024), ' ')));
     $this->options = explode("|", trim(strstr(fgets($fd, 1024), ' ')));
     $this->format = trim(strstr(fgets($fd, 1024), ' '));
@@ -55,7 +55,8 @@
     global $blog_baseurl, $blog_fancyurl;
 
     if ($blog_fancyurl) {
-      return $blog_baseurl . "/" . urlencode($this->category->name) . date("/Y/m/d/", $this->date) . $this->entryId . ".html";
+      $_category = preg_replace('/%2F/i','/',urlencode($this->category->name));
+      return $blog_baseurl . "/" . $_category . date("/Y/m/d/", $this->date) . $this->entryId . ".html";
     } else {
       return $blog_baseurl . '/entry.php?blogid=' . $this->entryId;
     }
@@ -119,7 +120,6 @@
     }
     $foptions = "";
     if (in_array("STATIC", $options)) {
-      print $title;
       $foptions .= "S";
     }
     $categoryclass = new Category($category);
@@ -166,8 +166,8 @@
   /**
    * static method
    */
-  function getEntryCount() {
-    return Soojung::queryNumFilenameMatch("^[0-9].+[.]entry$");
+  function getEntryCount($hide=true) {
+    return Soojung::queryNumFilenameMatch(Entry::_getQuery($hide));
   }
 
   /**
@@ -179,12 +179,25 @@
   }
 
   /**
+   * private static method
+   */
+  function _getQuery($hide) {
+    if ($hide == false) {
+      $query = "[.]entry$";
+    } else {
+      $query = "^[0-9].+[.]entry$";
+    }
+    return $query;
+  }
+
+  /**
    * static method
    */
-  function getEntries($count, $page) {
+  function getEntries($count, $page, $hide=true) {
     $entries = array();
-    $filenames = Soojung::queryFilenameMatch("^[0-9].+[.]entry$");
-    rsort($filenames);
+    $query = Entry::_getQuery($hide);
+    $filenames = Soojung::queryFilenameMatch($query);
+    usort($filenames, "cmp_base_filename");
     $index = ($page - 1) * $count;
 
     for ($i = $index; $i < count($filenames) && $i < ($index + $count); $i++) {
@@ -200,10 +213,7 @@
    */
   function getAllEntries($hide=true) {
     $entries = array();
-    $query = "^[0-9].+[.]entry$";
-    if ($hide == false) {
-      $query = "[.]entry$";
-    }
+    $query = Entry::_getQuery($hide);
     $filenames = Soojung::queryFilenameMatch($query);
     usort($filenames, "cmp_base_filename");
     foreach($filenames as $filename) {
@@ -215,8 +225,8 @@
   /**
    * static method
    */
-  function getRecentEntries($count=10) {
-    return Entry::getEntries($count, 1);
+  function getRecentEntries($count=10, $hide=true) {
+    return Entry::getEntries($count, 1, $hide);
   }
 
   /**
diff -urN soojung-0.4.5/classes/Formatter.class.php soojung/classes/Formatter.class.php
--- soojung-0.4.5/classes/Formatter.class.php	2005-02-19 05:37:25.000000000 +0900
+++ soojung/classes/Formatter.class.php	2005-02-24 23:15:59.000000000 +0900
@@ -211,8 +211,8 @@
         'BBcodeFormatter::__listing("\1","\2")',
         'BBcodeFormatter::__escape("<a href=\\"\1\\">\1</a>")',
         'BBcodeFormatter::__escape("<a href=\\"\2\\">\3</a>")',
-        'BBcodeFormatter::__escape("<img src=\\"\1\\" width=\\"\\" height=\\"\\" alt=\\"\1\\\" />")',
-        'BBcodeFormatter::__escape("<img src=\\"\2\\" width=\\"\\" height=\\"\\" alt=\\"\3\\\" />")',
+        'BBcodeFormatter::__escape("<img src=\\"\1\\" width=\\"\\" height=\\"\\" alt=\\"\1\\\" class=\\"bbcode\\" />")',
+        'BBcodeFormatter::__escape("<img src=\\"\2\\" width=\\"\\" height=\\"\\" alt=\\"\3\\\" class=\\"bbcode\\" />")',
         'BBcodeFormatter::__escape("<a href=\\"mailto:\1\\">\1</a>")'),
       $rule2 = array(
         '#http://(?:[-0-9a-z_.@:~\\#%=+?/]|&amp;)+#i',
diff -urN soojung-0.4.5/classes/Soojung.class.php soojung/classes/Soojung.class.php
--- soojung-0.4.5/classes/Soojung.class.php	2005-02-20 11:13:25.000000000 +0900
+++ soojung/classes/Soojung.class.php	2005-03-11 22:09:36.000000000 +0900
@@ -190,6 +190,8 @@
     fwrite($f, $_POST["url"] . "/index.php?archive=$1$2$3\n");
     fwrite($f, "RewriteRule ^([^/.]+)$ ");
     fwrite($f, $_POST["url"] . "/index.php?category=$1\n");
+    fwrite($f, "RewriteRule ^([^/.]+)/([^/.]+)$ ");
+    fwrite($f, $_POST["url"] . "/index.php?category=$1/$2\n");
     fwrite($f, "RewriteRule ^page/([0-9]+)$ ");
     fwrite($f, $_POST["url"] . "/index.php?page=$1\n");
     fclose($f);
diff -urN soojung-0.4.5/classes/Template.class.php soojung/classes/Template.class.php
--- soojung-0.4.5/classes/Template.class.php	2005-02-12 22:53:01.000000000 +0900
+++ soojung/classes/Template.class.php	2005-02-27 11:46:15.000000000 +0900
@@ -13,8 +13,8 @@
     
     $this->force_compile = false;
 
-    $this->assign('title', $blog_name);
-    $this->assign('description', $blog_desc);
+    $this->assign('title', htmlspecialchars($blog_name));
+    $this->assign('description', htmlspecialchars($blog_desc));
     $this->assign('baseurl', $blog_baseurl);
     $this->assign('soojung_version', $soojung_version);
   }
diff -urN soojung-0.4.5/entry.php soojung/entry.php
--- soojung-0.4.5/entry.php	2005-02-12 22:52:45.000000000 +0900
+++ soojung/entry.php	2005-03-11 22:03:46.000000000 +0900
@@ -44,9 +44,12 @@
 $template = new UserTemplate('entry.tpl', $blogid);
 if (!$template->is_cached('entry.tpl', $blogid)) {
   $entry = Entry::getEntry($blogid);
+  if ($entry->isSetOption("SECRET")) {
+    exit;
+  }
   $template->assign('entry', $entry);
   $template->assign('trackbacks', $entry->getTrackbacks());
-  $template->assign('comments', $entry->getComments());
+  $template->assign('comments', $entry->getComments());    
 }
 
 foreach (array('w_id','w_name','w_email','w_url') as $key) {
diff -urN soojung-0.4.5/install.php soojung/install.php
--- soojung-0.4.5/install.php	2005-02-19 18:37:52.000000000 +0900
+++ soojung/install.php	2005-02-24 23:20:56.000000000 +0900
@@ -1,6 +1,18 @@
 <?php
 include_once("classes/Soojung.class.php");
 include_once("libs/util.php");
+
+if (get_magic_quotes_gpc()) {
+  function stripslashes_deep($value) {
+    $value = is_array($value) ?
+      array_map('stripslashes_deep', $value) :
+      stripslashes($value);
+    return $value;
+  }
+  $_POST = array_map('stripslashes_deep', $_POST);
+  $_GET = array_map('stripslashes_deep', $_GET);
+  $_COOKIE = array_map('stripslashes_deep', $_COOKIE);
+}
 ?>
 
 <html>
diff -urN soojung-0.4.5/libs/common.js soojung/libs/common.js
--- soojung-0.4.5/libs/common.js	1970-01-01 09:00:00.000000000 +0900
+++ soojung/libs/common.js	2005-02-24 23:15:59.000000000 +0900
@@ -0,0 +1,18 @@
+function fold_sidebar(objid) {
+	document.getElementById(objid).className =
+		(document.getElementById(objid).className ? '' : 'hide');
+	return false;
+}
+
+function correct_bbcode_image() {
+	objs = document.getElementsByTagName('IMG');
+	for(i=0; i<objs.length; i++) {
+		obj = objs[i];
+		if(obj.className != 'bbcode') continue;
+		img = new Image();
+		img.src = obj.src;
+		obj.width = img.width;
+		obj.height = img.height;
+	}
+	return false;
+}
diff -urN soojung-0.4.5/post.php soojung/post.php
--- soojung-0.4.5/post.php	2005-02-19 05:37:25.000000000 +0900
+++ soojung/post.php	2005-03-11 23:19:19.000000000 +0900
@@ -1,10 +1,40 @@
 <?php
+session_cache_limiter('private'); 
 session_start();
 
+include("config.php");
 include("settings.php");
 
+if ($_POST["mode"] == "login") {
+  if (md5($_POST["password"]) == $admin_password)
+    $_SESSION['auth'] = TRUE;
+  $_POST["mode"] = $_POST["original_mode"];
+  $_POST["body"] = base64_decode($_POST["body"]);
+#  echo "mode = ". $_POST["mode"];
+} 
+
 if (!isset($_SESSION["auth"])) {
-  echo "<meta http-equiv='refresh' content='0;URL=admin.php'>";
+  $hidden_attr = array();
+  $param["name"] = "original_mode";
+  $param["value"] = $_POST["mode"];
+  $hidden_attr[] = $param;
+  
+  $list = array("title", "format", "date", "category", "category_input", "body", "SECRET", "NO_COMMENT", "NO_TRACKBACK", "STATIC", "NO_RSS");
+  foreach ($list as $key) {
+    if (array_key_exists($key, $_POST)) {
+      $param["name"] = $key;
+      if ($key == "body")
+	$param["value"] = base64_encode($_POST[$key]);
+      else
+	$param["value"] = htmlspecialchars($_POST[$key]);
+      $hidden_attr[] = $param;
+    }
+  }
+  
+  $template = new AdminTemplate;
+  $template->assign('original_dst', $_SERVER["PHP_SELF"]);
+  $template->assign('hidden_attr', $hidden_attr);
+  $template->display('login.tpl');
   exit;
 }
 
@@ -72,6 +102,7 @@
   $format = $_POST["format"];
   $formatter = Soojung::getFormatter($format);
   $body = $formatter->onPost($_POST["body"]);
+  $body = nl2br($body);
   $date = strtotime($_POST["date"]);
   if (empty($_POST["category_input"]) == false) {
     $category = trim($_POST["category_input"]);
diff -urN soojung-0.4.5/rss2.php soojung/rss2.php
--- soojung-0.4.5/rss2.php	2005-02-19 05:37:25.000000000 +0900
+++ soojung/rss2.php	2005-03-01 02:01:20.000000000 +0900
@@ -11,14 +11,14 @@
   function convenc($str) { return $str; }
 }
 
-header("Content-type: text/xml");
+header("Content-type: text/xml; charset=$encoding");
 echo "<?xml version=\"1.0\" encoding=\"$encoding\"?>\n";
 ?>
 <rss version="2.0">
 <channel>
-<title><?=convenc($blog_name)?></title>
+<title><?=htmlspecialchars(convenc($blog_name))?></title>
 <link><?=$blog_baseurl?></link>
-<description><?=convenc($blog_desc)?></description>
+<description><?=htmlspecialchars(convenc($blog_desc))?></description>
 <copyright></copyright>
 <pubDate><?=date('r')?></pubDate>
 <generator>soojung <?=$soojung_version?></generator>
@@ -42,11 +42,11 @@
   $post_text = $formatter->toRSS($post_text);
 
   echo "<item>\n";
-  echo "<title>" . convenc($e->title) . "</title>\n";
+  echo "<title>" . htmlspecialchars(convenc($e->title)) . "</title>\n";
   echo "<link>" . $e->getHref() . "</link>\n";
   echo "<pubDate>" . date('r', $e->date) . "</pubDate>\n";
-  echo "<category>" . convenc($e->category->name) . "</category>\n";
-  echo "<description>" . convenc(htmlspecialchars($post_text)) . "</description>\n";
+  echo "<category>" . htmlspecialchars(convenc($e->category->name)) . "</category>\n";
+  echo "<description>" . htmlspecialchars(convenc($post_text)) . "</description>\n";
   echo "</item>\n";
 }
 ?>
diff -urN soojung-0.4.5/settings.php soojung/settings.php
--- soojung-0.4.5/settings.php	2005-02-19 01:52:00.000000000 +0900
+++ soojung/settings.php	2005-03-11 22:03:46.000000000 +0900
@@ -1,8 +1,9 @@
 <?php
 
-$soojung_version = '0.4.5';
+$soojung_version = '0.4.6';
 setlocale(LC_TIME, "C");
 
+header("Content-type: text/html; charset=utf-8");
 if (!file_exists("config.php")) {
   echo "please execute install.php first.";
   exit;
diff -urN soojung-0.4.5/xmlrpc.php soojung/xmlrpc.php
--- soojung-0.4.5/xmlrpc.php	2005-02-19 11:08:17.000000000 +0900
+++ soojung/xmlrpc.php	2005-02-21 20:48:17.000000000 +0900
@@ -343,7 +343,7 @@
 				       "description" => new xmlrpcval($content, "string")
 				       ), "struct");
 
-    $structarray[] = $entrystruct; !d!,
+    $structarray[] = $entrystruct;
   }
   return new xmlrpcresp(new xmlrpcval($structarray, "array"));
 
